
package icfp2001;


public class Consolidator implements NodeVisitor
{
    protected boolean vLastNodeWasSpace = false;
    protected TextNode vLastNode = null;
    protected Context vLastContext = new Context();

    public Object visitTextNode(TextNode pTextNode) 
    {
        if ((vLastNode != null) && (!vLastNodeWasSpace))
        {
            if (vLastContext.equals(pTextNode.getEntryContext()))
            {
                synchronized(vLastNode)
                {
                    synchronized(pTextNode)
                    {
                        vLastNode.mText = vLastNode.mText + pTextNode.mText;
                        pTextNode.mText = "";
                    }
                }
            }
        }

        vLastNode = pTextNode;
        vLastNodeWasSpace = false;
        vLastContext = (Context)pTextNode.getEntryContext();
        return null;
    }

    public Object visitWhiteSpaceNode(WhiteSpaceNode pWhiteSpaceNode) 
    {
        SpaceContext vCurrentSpaceContext = new SpaceContext((Context)pWhiteSpaceNode.getEntryContext());
        if (!vCurrentSpaceContext.tt)
        {
            if (pWhiteSpaceNode.mText.length() > 0)
            {
                pWhiteSpaceNode.mText = " ";
            }
        }
    
        if ((vLastNode != null) && (vLastNodeWasSpace))
        {
            SpaceContext vLastSpaceContext = new SpaceContext(vLastContext);
            if (vLastSpaceContext.equals(vCurrentSpaceContext))
            {
                synchronized(vLastNode)
                {
                    synchronized(pWhiteSpaceNode)
                    {
                        vLastNode.mText = vLastNode.mText + pWhiteSpaceNode.mText;
                        pWhiteSpaceNode.mText = "";
                    }
                }
            }
        }

        vLastNode = pWhiteSpaceNode;
        vLastNodeWasSpace = true;
        vLastContext = (Context)pWhiteSpaceNode.getEntryContext();
        return null;
    }

    public Object visitTagNode(TagNode pTagNode)
    {
        visitChildren(pTagNode);
        return null;
    }
    public Object visitRootNode(RootNode pRootNode)
    {
        vLastNodeWasSpace = false;
        vLastNode=null;
        vLastContext = new Context();
        visitChildren(pRootNode);
        return null;
    }

    protected Node visitChildren(Node pNode)
    {
        for (int i = 0; i < pNode.numChildren(); i++)
        {
            pNode.getChild(i).accept(this);
        }

        return null;
    }
    
    
}

