package icfp2001;

public class Context implements Cloneable
{
    public final static Object ENTRY_CONTEXT = new Object();

    public boolean b=false;
    public boolean em=false;
    public boolean i=false;
    public boolean s=false;
    public boolean tt=false;
    public int u=0;
    public int size=SIZE_DEFAULT;
    public int color=COLOR_DEFAULT;

    public final static int COLOR_DEFAULT=0;
    public final static int COLOR_R=1;
    public final static int COLOR_G=2;
    public final static int COLOR_B=3;
    public final static int COLOR_C=4;
    public final static int COLOR_M=5;
    public final static int COLOR_Y=6;
    public final static int COLOR_K=7;
    public final static int COLOR_W=8;

    public final static int SIZE_DEFAULT=-1;

    public void uTag() 
    {
        if (u < 3)
        {
            u++;
        }
    }

    public void bTag()
    {
        b=true;
    }

    public void emTag()
    {
        if (!s)
        {
            em = !em;
        }
    }

    public void iTag()
    {
        i=true;
    }

    public void plTag()
    {
        s=false;
        em=false;
        i=false;
        b=false;
        tt=false;
        u=0;
    }

    public void sTag()
    {
        s=true;
        em=false;
    }

    public void ttTag()
    {
        tt=true;
    }

    public Object clone()
    {
        try
        {
            return super.clone();
        }
        catch (CloneNotSupportedException vEx)
        {
            throw new InternalError("Context Clone error");
        }
    }

    public boolean equals(Object pObj) 
    {
        if (pObj instanceof Context)
        {
            Context vContext = (Context)pObj;

            return (this.b == vContext.b &&
                    this.em == vContext.em &&
                    this.i == vContext.i &&
                    this.s == vContext.s &&
                    this.tt == vContext.tt &&
                    this.u == vContext.u &&
                    this.size == vContext.size &&
                    this.color == vContext.color);
        }
        else
        {
            return false;
        }
    }

    public int hashCode()
    {
        int vHash = 0;
        vHash += b ? 0 : 1;
        vHash += em ? 0 : 2;
        vHash += i ? 0 : 4;
        vHash += s ? 0 : 8;
        vHash += tt ? 0 : 16;
        vHash = vHash*4 + u;
        vHash = vHash*10 + size;
        vHash = vHash*9 + color;

        return vHash;
    }

    public String toString()
    {
        StringBuffer vBuf = new StringBuffer("[");
        if (b)
        {
            vBuf.append("B");
        }
        if (em)
        {
            vBuf.append("EM");
        }
        if (i)
        {
            vBuf.append("I");
        }
        if (s)
        {
            vBuf.append("S");
        }
        if (tt)
        {
            vBuf.append("TT");
        }
        vBuf.append("U");
        vBuf.append(u);
        vBuf.append("SZ");
        vBuf.append(size);
        switch (color)
        {
            case COLOR_DEFAULT:
                vBuf.append("d");
                break;
            case COLOR_R:
                vBuf.append("r");
                break;
            case COLOR_G:
                vBuf.append("g");
                break;
            case COLOR_B:
                vBuf.append("b");
                break;
            case COLOR_C:
                vBuf.append("c");
                break;
            case COLOR_M:
                vBuf.append("m");
                break;
            case COLOR_Y:
                vBuf.append("y");
                break;
            case COLOR_K:
                vBuf.append("k");
                break;
            case COLOR_W:
                vBuf.append("w");
                break;
        }

        vBuf.append("]");
        return vBuf.toString();
    }

    /**
     * Creates a new context which is the result of applying a tag to
     * this one
     *
     */
    public Context applyTags(TagNode pNode)
    {
        Context vClone = (Context)clone();

        if (pNode.isBTag())
        {
            vClone.bTag();
        }
        if (pNode.isEMTag())
        {
            vClone.emTag();
        }
        if (pNode.isITag())
        {
            vClone.iTag();
        }
        if (pNode.isPLTag())
        {
            vClone.plTag();
        }
        if (pNode.isSTag())
        {
            vClone.sTag();
        }
        if (pNode.isTTTag())
        {
            vClone.ttTag();
        }
        if (pNode.isUTag())
        {
            vClone.uTag();
        }

        if (pNode.isColorTag())
        {
            vClone.color = pNode.getColorValue();
        }

        if (pNode.isSizeTag())
        {
            vClone.size = pNode.getSize();
        }
         
        return vClone;  
    }
}
