
package icfp2001;


/**
 * This class outputs associates contexts with all the nodes
 *
 */
public class ContextFiller implements NodeVisitor 
{
    protected Context mCurrentContext;

    public ContextFiller()
    {
        mCurrentContext = new Context();
    }

    public void setContext(Context vContext)
    {
        mCurrentContext = vContext;
    }

    public Object visitTextNode(TextNode pTextNode) 
    {
        pTextNode.setEntryContext( mCurrentContext);
        return null;
    }

    public Object visitWhiteSpaceNode(WhiteSpaceNode pWhiteSpaceNode) 
    {
        pWhiteSpaceNode.setEntryContext( mCurrentContext);
        return null;
    }

    public Object visitTagNode(TagNode pTagNode)
    {
        pTagNode.setEntryContext( mCurrentContext);
        Context vOldContext = mCurrentContext;
        mCurrentContext = mCurrentContext.applyTags(pTagNode);
        visitChildren(pTagNode);
        mCurrentContext = vOldContext;
        return null;
    }

 
    public Object visitRootNode(RootNode pRootNode)
    {
        mCurrentContext = new Context();
        pRootNode.setEntryContext( mCurrentContext);
        visitChildren(pRootNode);
        return null;
    }
    

    protected void visitChildren(Node pNode)
    {
        for (int i = 0; i < pNode.numChildren(); i++)
        {
            pNode.getChild(i).accept(this);
        }
    }
}


