
package icfp2001;


public class EditorVisitor implements NodeVisitor
{

    protected boolean editableNode(TextNode pNode)
    {
        return false;
    }

    protected Node edit(TextNode pNode)
    {
        return pNode;
    }

    public Object visitTextNode(TextNode pTextNode) 
    {
        if (editableNode(pTextNode))
        {
            Node vTopNode = edit(pTextNode);

            if (vTopNode == null || vTopNode.equals(pTextNode))
            {
                return null;
            }
            else
            {
                return vTopNode;
            }
        }
        return null;
    }

    protected boolean editableNode(WhiteSpaceNode pNode)
    {
        return false;
    }

    protected Node edit(WhiteSpaceNode pNode)
    {
        return pNode;
    }
    
    public Object visitWhiteSpaceNode(WhiteSpaceNode pWhiteSpaceNode) 
    {
        if (editableNode(pWhiteSpaceNode))
        {
            Node vTopNode = edit(pWhiteSpaceNode);

            if (vTopNode == null || vTopNode.equals(pWhiteSpaceNode))
            {
                return null;
            }
            else
            {
                return vTopNode;
            }
        }
        return null;
    }

    protected boolean editableNode(TagNode pNode)
    {
        return false;
    }

    protected Node edit(TagNode pNode)
    {
        return pNode;
    }

    public Object visitTagNode(TagNode pTagNode)
    {
        Node vTopNode = visitChildren(pTagNode);

        if (vTopNode == null || vTopNode.equals(pTagNode)) 
        {
            if (editableNode(pTagNode))
            {
                vTopNode = edit(pTagNode);

                if (vTopNode == null || vTopNode.equals(pTagNode))
                {
                    return null;
                }
                else
                {
                    return vTopNode;
                }
            }
        }
        return null;
    }

    protected boolean editableNode(RootNode pNode)
    {
        return false;
    }

    protected Node edit(RootNode pNode)
    {
        return pNode;
    }

    public Object visitRootNode(RootNode pRootNode)
    {
        Node vTopNode = visitChildren(pRootNode);

        if (vTopNode == null || vTopNode.equals(pRootNode)) 
        {
            if (editableNode(pRootNode))
            {
                vTopNode = edit(pRootNode);

                if (vTopNode == null || vTopNode.equals(pRootNode))
                {
                    return null;
                }
                else
                {
                    return vTopNode;
                }
            }
        }
        return null;
    }

    protected Node visitChildren(Node pNode)
    {
        Node vTopNode = pNode;
        int vLoops = 0;

        while (vTopNode == pNode && vLoops++ < 100)
        {
            vTopNode = null;
            
            for (int i = 0; vTopNode == null && i < pNode.numChildren(); i++)
            {
                vTopNode = (Node)pNode.getChild(i).accept(this);
            }
        }

        return vTopNode;
    }
    
    
}
