package icfp2001;

public class EmptyTagDeleter extends EditorVisitor
{
    protected boolean editableNode(TextNode pNode)
    {
        return (pNode.mText == null || pNode.mText.length() == 0);
    }

    protected Node edit(TextNode pNode)
    {
        Node vParent = pNode.getParent();

        if (vParent != null)
        {
            synchronized (vParent)
            {
                pNode.detach();
            }
        }
        return vParent;
    }

    protected boolean editableNode(WhiteSpaceNode pNode)
    {
        return (pNode.mText == null || pNode.mText.length() == 0);
    }

    protected Node edit(WhiteSpaceNode pNode)
    {
        Node vParent = pNode.getParent();

        if (vParent != null)
        {
            synchronized (vParent)
            {
                pNode.detach();
            }
        }
        return vParent;
    }


    protected boolean editableNode(TagNode pNode)
    {
        return (pNode.numChildren() == 0);
    }

    protected Node edit(TagNode pNode)
    {
        Node vParent = pNode.getParent();

        if (vParent != null)
        {
            synchronized (vParent)
            {
                pNode.detach();
            }
        }
        return vParent;
    }
    
}
