package icfp2001;

public class LeftSidePromoter extends EditorVisitor
{

    protected boolean editableNode(TagNode pNode)
    {
        if (pNode.numChildren() > 0)
        {
            Node vChild = pNode.getChild(0);
            if (pNode != null)
            {
                Context vParentContext = pNode.getEntryContext();
                if (vParentContext != null)
                {
                    if (vParentContext.equals(vChild.getEntryContext()))
                    {
                        return true;
                    }
                    else if (vChild instanceof WhiteSpaceNode)
                    {
                        SpaceContext vParentSpaceContext = new SpaceContext(vParentContext);
                        SpaceContext vChildSpaceContext = new SpaceContext(vChild.getEntryContext());

                        if (vParentSpaceContext.equals(vChildSpaceContext))
                        {
                            return true;
                        }
                    }
                    else if (vChild instanceof TagNode)
                    {
                        Context vPotentialPromoteContext = vParentContext.applyTags((TagNode)vChild);
                        Context vCurrentResultContext = vChild.getEntryContext().applyTags((TagNode)vChild);

                        if (vPotentialPromoteContext.equals(vCurrentResultContext))
                        {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    protected Node edit(TagNode pNode)
    {
        Node vParent = pNode.getParent();

        if (vParent != null)
        {

            int vParentIndex = vParent.getChildIndex(pNode);
            Node vChild = pNode.getChild(0);
            Context vEntryContext = pNode.getEntryContext();

            synchronized(vParent)
            {
                vChild.detach();
                vParent.insertChild(vParentIndex, vChild);
                vChild.setEntryContext(vEntryContext);
            }
        }
        return vParent;
    }
    
}

