package icfp2001;

/**
 * Visitor for Nodes. See Visitor design pattern
 *
 */
public interface NodeVisitor {

    /**
     * Visits a TextNode
     *
     * @param pTextNode the TextNode to visit
     *
     * @return pReturn the result of the visit.
     */
    public Object visitTextNode(TextNode pTextNode);

    /**
     * Visits a WhiteSpaceNode
     *
     * @param pWhiteSpaceNode the WhiteSpaceNode to visit
     *
     * @return pReturn the result of the visit.
     */
    public Object visitWhiteSpaceNode(WhiteSpaceNode pWhiteSpaceNode);

    /**
     * Visits a TagNode
     *
     * @param pTagNode the TagNode to visit
     *
     * @return pReturn the result of the visit.
     */
    public Object visitTagNode(TagNode pTagNode);

    /**
     * Visits a RootNode
     *
     * @param pRootNode the RootNode to visit
     *
     * @return pReturn the result of the visit.
     */
    public Object visitRootNode(RootNode pRootNode);

}
