package icfp2001;

import java.io.*;

public class Optimizer extends Thread
{
    protected RootNode mRoot;

    protected NodeVisitor vEds[] = {new Consolidator(),
                                    new TagCollapser(),
                                    new EmptyTagDeleter(),
                                    new LeftSidePromoter(),
                                    new RightSidePromoter(),
                                    new Absorber()
                                    };

    public Optimizer(RootNode vRootNode)
    {
        mRoot = vRootNode;
    }

    public void run()
    {
        while (true)
        {
            for (int i = 0; i < vEds.length; i++)
            {
//System.out.println("Doing: "+ vEds[i]);
//NodeWriter.print(mRoot);
//System.out.println();
                vEds[i].visitRootNode(mRoot);
//System.out.println("Done:" + vEds[i]);               
//NodeWriter.print(mRoot);
//System.out.println();
            }
        }
    }

    public final static int SAFETYFACTOR = 10;

    public static void main(String vArgs[])
    {
        try
        {
            IcfpParser vParser;

            int vTimeLimit = Integer.parseInt(vArgs[0]);

            vParser = new IcfpParser(System.in);

            RootNode vNode = (RootNode)vParser.rootNode();

            ContextFiller vFiller = new ContextFiller();
            vFiller.visitRootNode(vNode);

//NodeWriter.print(vNode);
//Expander vEx = new Expander(5);
//vNode.accept(vEx);
//NodeWriter.print(vNode);

            Optimizer vOpt = new Optimizer(vNode);

            vOpt.start();

            SafeNodeWriter vWriter = new SafeNodeWriter(System.out);

            if (vTimeLimit < SAFETYFACTOR)
            {
                vTimeLimit = SAFETYFACTOR+1;
            }
            vOpt.join((vTimeLimit-SAFETYFACTOR)*1000);

            vWriter.visitRootNode(vNode);

            System.exit(0);
        }
        catch (Exception vException)
        {
            vException.printStackTrace();
        }
    }
}

