package icfp2001;

public class RightSidePromoter extends EditorVisitor
{

    protected boolean editableNode(TagNode pNode)
    {
        if (pNode.numChildren() > 0)
        {
            int vNumChildren = pNode.numChildren();
            Node vChild = pNode.getChild(vNumChildren-1);
            if (pNode != null)
            {
                Context vParentContext = pNode.getEntryContext();
                if (vParentContext != null)
                {
                    if (vParentContext.equals(vChild.getEntryContext()))
                    {
                        return true;
                    }
                    else if (vChild instanceof WhiteSpaceNode)
                    {
                        SpaceContext vParentSpaceContext = new SpaceContext(vParentContext);
                        SpaceContext vChildSpaceContext = new SpaceContext(vChild.getEntryContext());

                        if (vParentSpaceContext.equals(vChildSpaceContext))
                        {
                            return true;
                        }
                    }
                    else if (vChild instanceof TagNode)
                    {
                        Context vPotentialPromoteContext = vParentContext.applyTags((TagNode)vChild);
                        Context vCurrentResultContext = vChild.getEntryContext().applyTags((TagNode)vChild);

                        if (vPotentialPromoteContext.equals(vCurrentResultContext))
                        {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    protected Node edit(TagNode pNode)
    {
        Node vParent = pNode.getParent();

        if (vParent != null)
        {
            int vNumParentChildren = vParent.numChildren();
            int vParentIndex = vParent.getChildIndex(pNode);
            Node vChild = pNode.getChild(pNode.numChildren()-1);
            Context vEntryContext = pNode.getEntryContext();

            synchronized(vParent)
            {
                vChild.detach();
                if (vParentIndex+1 < vNumParentChildren)
                {
                    vParent.insertChild(vParentIndex+1, vChild);
                }
                else 
                {
                    vParent.addChild(vChild);
                }
                vChild.setEntryContext(vEntryContext);
            }
        }

        return vParent;
    }
    
}


