
package icfp2001;

import java.io.*;
import java.util.*;

/**
 * This class outputs the nodes to a PrintStream
 *
 */
public class SafeNodeWriter extends NodeWriter
{

    /**
     * Constructs a new node writer
     *
     * @param pWriter the print writer
     */
    public SafeNodeWriter(PrintStream pWriter) 
    {
        super(pWriter);
    }

    public Object visitTextNode(TextNode pTextNode) 
    {
        synchronized (pTextNode)
        {
            return super.visitTextNode(pTextNode);
        }
    }

    public Object visitWhiteSpaceNode(WhiteSpaceNode pWhiteSpaceNode) 
    {
        synchronized (pWhiteSpaceNode)
        {
            return super.visitWhiteSpaceNode(pWhiteSpaceNode);
        }
    }

    public Object visitTagNode(TagNode pTagNode)
    {
        synchronized (pTagNode)
        {
            return super.visitTagNode(pTagNode);
        }
    }

    public Object visitRootNode(RootNode pRootNode)
    {
        synchronized (pRootNode)
        {
            return super.visitRootNode(pRootNode);
        }
    }
}


