package icfp2001;

/**
 * A Node which contains text
 *
 */
public class TextNode extends Node {

    /**
     * The contents of this text node
     */
    protected String mText;
    
    /**
     * Creates a new TextNode
     *
     * @param pText the desired contents of the new node
     */
    public TextNode(String pText) {
        mText = pText;
    }

    public Object accept(NodeVisitor pVisitor)
    {
        return pVisitor.visitTextNode(this);
    }

    /**
     * Returns the text in this node
     *
     * @return the contents of this node
     */
    public String getText()
    {
        return mText;
    }

}
